stages:
  - static-analysis
  - deploy
  - build
  - publish

lint:
  stage: static-analysis
  image:
    name: ckleemann/prospector:latest
    entrypoint:
    - ''
  before_script:
  - pip install --upgrade pip
  - pip install poetry
  - poetry install
  script:
  - poetry run prospector -P ./prospector-profile.yml ./
  allow_failure: true
  except:
    - tags

semgrep:
  stage: static-analysis
  image: returntocorp/semgrep-agent:v1
  script: semgrep-agent
  variables:
    INPUT_CONFIG: p/security-audit p/secrets
  except:
    - tags

build-docker:
  stage: build
  image: docker:20
  services:
    - docker:20-dind
  script:
    - docker login --username $CI_REGISTRY_USER --password $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:latest
    - >
      docker build
      --cache-from $CI_REGISTRY_IMAGE:latest
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      --tag $CI_REGISTRY_IMAGE:latest
      .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest
  except:
    - tags

release:
  stage: publish
  image: docker:20
  rules:
    - if: $CI_PROJECT_NAMESPACE == "rock-on.space" && $CI_COMMIT_TAG =~ /^v/
  services:
    - docker:20-dind
  script:
    - docker login --username $CI_REGISTRY_USER --password $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

